xine-lib: xine-lib-1.2.12/src/video_dec/libaom.c File Reference

xine-lib 1.2.12

Data Structures | Macros | Typedefs | Functions | Variables
libaom.c File Reference
`#include <stdlib.h>`
`#include <aom/aom_decoder.h>`
`#include <aom/aomdx.h>`
`#include <xine/xine_internal.h>`
`#include <xine/video_out.h>`
`#include <xine/buffer.h>`
`#include <xine/xineutils.h>`

## Data Structures
struct | aom_decoder_s

## Macros
#define | LOG_MODULE "libaom_video_decoder"
#define | LOG_VERBOSE

## Typedefs
typedef struct aom_decoder_s | aom_decoder_t

## Functions
static void | _copy_yv12_16_to_8 (vo_frame_t *img, struct aom_image *aom_img, int width, int height)
static void | _draw_image (aom_decoder_t *this, aom_image_t *aom_img)
static void | _decode (aom_decoder_t *this, const uint8_t *buf, size_t size)
static void | _aom_decode_data (video_decoder_t *this_gen, buf_element_t *buf)
static void | _aom_flush (video_decoder_t *this_gen)
static void | _aom_reset (video_decoder_t *this_gen)
static void | _aom_discontinuity (video_decoder_t *this_gen)
static void | _aom_dispose (video_decoder_t *this_gen)
static video_decoder_t * | _open_plugin (video_decoder_class_t *class_gen, xine_stream_t *stream)
static void * | init_plugin_aom (xine_t *xine, const void *data)

## Variables
static const uint32_t | video_types_aom []
static const decoder_info_t | dec_info_video_aom
const plugin_info_t xine_plugin_info[] | EXPORTED

## Macro Definition Documentation

## ◆ LOG_MODULE

#define LOG_MODULE "libaom_video_decoder"

## ◆ LOG_VERBOSE

#define LOG_VERBOSE

## Typedef Documentation

## ◆ aom_decoder_t

typedef struct aom_decoder_s aom_decoder_t

## Function Documentation

## ◆ _aom_decode_data()

static void _aom_decode_data | ( | video_decoder_t * | this_gen,
|  | buf_element_t * | buf
| ) |  |
| static

References _decode(), BUF_FLAG_ASPECT, BUF_FLAG_FRAME_END, BUF_FLAG_PREVIEW, BUF_FLAG_SPECIAL, BUF_FLAG_STDHEADER, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, buf_element_s::pts, buf_element_s::size, and xine_fast_memcpy.

Referenced by _open_plugin().

## ◆ _aom_discontinuity()

static void _aom_discontinuity | ( | video_decoder_t * | this_gen | ) |
| static

References _aom_flush().

Referenced by _open_plugin().

## ◆ _aom_dispose()

static void _aom_dispose | ( | video_decoder_t * | this_gen | ) |
| static

References _x_freep().

Referenced by _open_plugin().

## ◆ _aom_flush()

static void _aom_flush | ( | video_decoder_t * | this_gen | ) |
| static

References _decode(), and NULL.

Referenced by _aom_discontinuity(), and _open_plugin().

## ◆ _aom_reset()

static void _aom_reset | ( | video_decoder_t * | this_gen | ) |
| static

References NULL.

Referenced by _open_plugin().

## ◆ _copy_yv12_16_to_8()

static void _copy_yv12_16_to_8 | ( | vo_frame_t * | img,
|  | struct aom_image * | aom_img,
|  | int | width,
|  | int | height
| ) |  |
| static

References vo_frame_s::base, height, vo_frame_s::pitches, and width.

Referenced by _draw_image().

## ◆ _decode()

static void _decode | ( | aom_decoder_t * | this,
|  | const uint8_t * | buf,
|  | size_t | size
| ) |  |
| static

References _draw_image(), _x_meta_info_set_utf8(), _x_stream_info_set(), LOG_MODULE, NULL, XINE_META_INFO_VIDEOCODEC, XINE_STREAM_INFO_VIDEO_HEIGHT, XINE_STREAM_INFO_VIDEO_RATIO, XINE_STREAM_INFO_VIDEO_WIDTH, XINE_VERBOSITY_LOG, and xprintf.

Referenced by _aom_decode_data(), and _aom_flush().

## ◆ _draw_image()

static void _draw_image | ( | aom_decoder_t * | this,
|  | aom_image_t * | aom_img
| ) |  |
| static

References _copy_yv12_16_to_8(), vo_frame_s::bad_frame, vo_frame_s::base, vo_frame_s::draw, vo_frame_s::flags, vo_frame_s::free, vo_frame_s::height, height, LOG_MODULE, vo_frame_s::pitches, vo_frame_s::progressive_frame, vo_frame_s::pts, VO_BOTH_FIELDS, VO_GET_FRAME_MAY_FAIL, VO_SET_FLAGS_CM, vo_frame_s::width, width, XINE_IMGFMT_YV12, XINE_VERBOSITY_LOG, xprintf, and yv12_to_yv12().

Referenced by _decode().

## ◆ _open_plugin()

static video_decoder_t * _open_plugin | ( | video_decoder_class_t * | class_gen,
|  | xine_stream_t * | stream
| ) |  |
| static

References _aom_decode_data(), _aom_discontinuity(), _aom_dispose(), _aom_flush(), _aom_reset(), LOG_MODULE, NULL, xine_stream_s::xine, xine_cpu_count(), xine_log(), XINE_LOG_MSG, XINE_VERBOSITY_DEBUG, and xprintf.

Referenced by init_plugin_aom().

## ◆ init_plugin_aom()

static void * init_plugin_aom | ( | xine_t * | xine,
|  | const void * | data
| ) |  |
| static

References _open_plugin(), N_, NULL, and video_decoder_class_s::open_plugin.

## Variable Documentation

## ◆ dec_info_video_aom

const decoder_info_t dec_info_video_aom
| static

Initial value:
= {
.supported_types = video_types_aom,
.priority = 1,
}
video_types_aom
static const uint32_t video_types_aom[]
Definition: libaom.c:361

## ◆ EXPORTED

const plugin_info_t xine_plugin_info [] EXPORTED

Initial value:
= {
{ PLUGIN_VIDEO_DECODER, 19, "libaom", XINE_VERSION_CODE, &dec_info_video_aom, init_plugin_aom },
{ PLUGIN_NONE, 0, NULL, 0, NULL, NULL }
}
dec_info_video_aom
static const decoder_info_t dec_info_video_aom
Definition: libaom.c:366
init_plugin_aom
static void * init_plugin_aom(xine_t *xine, const void *data)
Definition: libaom.c:342
XINE_VERSION_CODE
#define XINE_VERSION_CODE
Definition: xine_internal.h:57
NULL
NULL
Definition: xine_plugin.c:78
PLUGIN_NONE
#define PLUGIN_NONE
Definition: xine_plugin.h:29
PLUGIN_VIDEO_DECODER
#define PLUGIN_VIDEO_DECODER
Definition: xine_plugin.h:33

## ◆ video_types_aom

const uint32_t video_types_aom[]
| static

Initial value:
= {
BUF_VIDEO_AV1,
0
}
BUF_VIDEO_AV1
#define BUF_VIDEO_AV1
Definition: buffer.h:197